#include "sndawk.lx.h"
#include <stdio.h>
#include "red.h"

%%
@	VEXPLIST
/*
 * VEXPLIST est remplace par VSTAT2
 */
			if((first -> frereg -> symbtype == LPAROUVR &&
			    first ->  frered -> symbtype ==  LPARFERM) ||
			   (first -> frereg -> symbtype == LCROOUVR &&
			    first ->  frered -> symbtype ==  LCROFERM))
				STYPE(first,VALTEXP)
			else	if(first -> frereg -> symbtype == LPAROUVR &&
				first -> frereg -> frereg -> symbtype == LFOR)
				STYPE(first,VF1)
			else	if(first -> frereg -> symbtype == VFOR1)
				STYPE(first,VF2)
			else	if(first -> frereg -> symbtype == VFOR2)
				STYPE(first,VF3)
			else	STYPE(first,VSTAT2)
			R

@	VEXPALT
/*
 * VEXPALT est remplace par VEXP
 */
			STYPE(first,VEXP)
			R

@	VLOGEXP
/*
 * VLOGEXP est remplace par VEXPALT
 */
			STYPE(first,VEXPALT)
			R

@	VRELEXP
/*
 * VRELEXP est remplace par VLOGEXP
 */
			STYPE(first,VLOGEXP)
			R

@	VARTEXP
/*
 * VARTEXP est remplace par VRELEXP
 */
			STYPE(first,VRELEXP)
			R

@	VTERM
/*
 * VTERM est remplace par VARTEXP
 */
			STYPE(first,VARTEXP)
			R

@	LUNOP	VFACT0
/*
 * Si LUNOP est "-" il s'insert entre VFACT0 et son fils.
 * S'il est "+" il disparait.
 */
			LIEN(first->frereg,last)
			if(first -> lexval.ival == MINUS) {
				FILS(first,last)
			}
			else
				free(first);
			R

@	LFUNC	VFACT0
			LIEN(first->frereg,last)
			FILS(first,last)
			R

@	VFACT
/*
 * VFACT est remplace par VTERM
 */
			STYPE(first,VTERM)
			R

@	VFACT0
/*
 * VFACT0 est remplace par VFACT
 */
			if (first -> frered -> symbtype == LPOSTOP)
				STYPE(first,VFACTP)
			else	STYPE(first,VFACT)
			R

@	VLVAL
/*
 * VLVAL est remplace par VFACT0
 */
			if(first -> frered -> symbtype == LINCDEC)
				STYPE(first,VLVALX)
			else	STYPE(first,VFACT0)
			R

@	LNUM
/*
 * Un nouveau SYMB est cree de valeur VFACT. Des LIENs sont crees entre le
 * frere gauche de LNUM ou LVAR et VFACT et entre cului-ci et le frere
 * droit de LNUM ou LVAR qui devient le fils de VFACT.
 */
			SALLOC
			STYPE(symb,VFACT0)
			LIEN(first->frereg,symb)
			LIEN(symb,last->frered)
			FILS(first,symb)
			R

@	LISAMPS
@	LOSAMPS
			SALLOC
			if(first -> symbtype == LISAMPS)
				STYPE(symb,VFACT0)
			else
				STYPE(symb,VLVAL)
			LIEN(first->frereg,symb)
			LIEN(symb,last->frered)
			FILS(first,symb)
			SALLOC
			STYPE(symb,LNUM)
			symb -> lexval.fval = 0.0;
			first -> fils = symb;
			SALLOC
			symb -> lexval.fval = 1.0;
			STYPE(symb,LNUM)
			first -> fils -> frered = symb;
			R



@	LVAR
@	LSVAR
/*
 * Un nouveau SYMB est cree de valeur VLVAL. Des LIENs sont crees entre le
 * frere gauche de LVAR et entre cului-ci et le frere
 * droit de LVAR qui devient le fils de VLVAL.
 */
			SALLOC
			STYPE(symb,VLVAL)
			LIEN(first->frereg,symb)
			LIEN(symb,last->frered)
			FILS(first,symb)
			R

@	LPAROUVR	VALTEXP	LPARFERM
/*
 * Des LIENs sont crees entre le frere gauche de la paranthese ouvrante et
 * VALTEXP et entre celui-ci et le frere droit de la paranthese fermante.
 * VALTEXP change en VFACT et les parantheses disparessent.
 */
			LIEN(first->frereg,first->frered)
			LIEN(last->frereg,last->frered)
			STYPE(last->frereg,VFACT0)
			free(first);
			free(last);
			R

@	VEXPLIST	LVIRGULE	VEXP
@	VLOGEXP	LOGOP	VRELEXP
@	VRELEXP	LRELOP	VARTEXP
@	VARTEXP	LARTOP1	VTERM
@	VTERM	LARTOP2	VFACT
@	VFACT	LARTOP3	VFACT0
/*
 * Le sousarbre du dernier terme ou facteur devient le frere droit du
 * sousarbre du premier terme ou expression. L'operateur devient leur
 * nouveau pere et le fils du premier terme ou expression. Le deuxieme
 * terme ou facteur disparait.
 */
			LIEN(first->fils,last->fils)
			FILS(first->frered,first)
			LIEN(first,last->frered)
			free(last);
			R

@	VLVALX	LINCDEC
@	VFACTP	LPOSTOP
			STYPE(first,VFACT0)
			LIEN(first,last -> frered)
			FILS(last,first)
			R

@	LDECINC	VLVAL
			STYPE(last,VFACT0)
			LIEN(first -> frereg ,last)
			FILS(first,last)
			R

@	LINCDEC
			STYPE(last,LDECINC)
			R
